#!/bin/bash

GSTL=gst-launch-1.0
VSINK=waylandsink
ASINK=alsasink
FSCR=true

#######################################
# usage
# file-play  video+audio  /wssd/gst-test/SKYFALL-4K.mp4SKYFALL-4K.mp4  v4l2h264dec  avdec_aac
file-play() {

if [ "$1" == "video+audio" ] ; then
$GSTL -v filesrc location=$2 \
    ! parsebin name=pb \
    pb. ! $3 ! queue \
    ! v4l2convert output-io-mode=dmabuf-import capture-io-mode=dmabuf ! queue \
    ! $VSINK fullscreen=true \
    pb. ! $4 ! queue \
    ! audioconvert ! queue ! $ASINK

elif [ "$1" == "only-video" ] ; then
$GSTL -v filesrc location=$2 \
    ! parsebin ! $3 ! queue \
    ! v4l2convert output-io-mode=dmabuf-import capture-io-mode=dmabuf ! \
    ! queue ! $VSINK fullscreen=true

elif [ "$1" == "only-audio" ] ; then
$GSTL -v filesrc location=$2 \
    ! parsebin ! $4 ! queue \
    ! audioconvert ! queue ! $ASINK
fi

}

#######################################
# usage
# uri-play  video+audio    http://storage.googleapis.com/boundarydevices.com/trailers/Hobbit-1080p.mov  v4l2h264dec    avdec_aac      1280       720
# uri-play  <stream-type>  <URI>                                                                        <vid-decoder>  <aud-decoder>  <width>  <height>
uri-play() {

if [ "$1" == "video+audio" ] ; then
$GSTL -v souphttpsrc location=$2  typefind=true is-live=true \
    ! parsebin name=pb \
    pb. ! $3 ! queue \
    ! v4l2convert output-io-mode=dmabuf-import capture-io-mode=dmabuf ! queue \
    ! $VSINK window-width=$5 window-height=$6 \
    pb. ! $4 ! queue \
    ! audioconvert ! queue ! $ASINK

elif [ "$1" == "only-video" ] ; then
$GSTL -v souphttpsrc location=$2  typefind=true is-live=true \
    ! parsebin ! $3 ! queue \
    ! v4l2convert output-io-mode=dmabuf-import capture-io-mode=dmabuf ! queue \
    ! $VSINK fullscreen=true


elif [ "$1" == "only-audio" ] ; then
$GSTL -v souphttpsrc location=$2  typefind=true is-live=true \
    ! parsebin ! $4 ! queue \
    ! audioconvert ! queue ! $ASINK
fi

}

# uri-play-full  video+audio  http://storage.googleapis.com/boundarydevices.com/trailers/Hobbit-1080p.mov  v4l2h264dec  avdec_aac
uri-play-full() {

if [ "$1" == "video+audio" ] ; then
$GSTL -v souphttpsrc location=$2  typefind=true is-live=true \
    ! parsebin name=pb \
    pb. ! $3 ! queue \
    ! v4l2convert output-io-mode=dmabuf-import capture-io-mode=dmabuf ! queue \
    ! $VSINK fullscreen=true \
    pb. ! $4 ! queue \
    ! audioconvert ! queue ! $ASINK

elif [ "$1" == "only-video" ] ; then
$GSTL -v souphttpsrc location=$2  typefind=true is-live=true \
    ! parsebin ! $3 ! queue \
    ! v4l2convert output-io-mode=dmabuf-import capture-io-mode=dmabuf ! queue \
    ! $VSINK fullscreen=true


elif [ "$1" == "only-audio" ] ; then
$GSTL -v souphttpsrc location=$2  typefind=true is-live=true \
    ! parsebin ! $4 ! queue \
    ! audioconvert ! queue ! $ASINK
fi

}

# youtube-play  video+audio  https://www.youtube.com/watch?v=NsbVTPftcgs  v4l2vp9dec  opusdec  1280  720
youtube-play() {
    location="$(yt-dlp --format '(best)[ext=mp4][protocol=https]' --get-url $2)"
    uri-play  $1  "$location"  $3  $4  $5  $6
}
